// File: rsw.h
//
// Time-stamp: <2008-07-17 18:52:54 haog>
// Author: Guohua Hao <haog@eecs.oregonstate.edu>
//
// Copyright (C) 2008 Guohua Hao
// All Rights Reserved.
//
// Description: RswEval class, which is the recurrent sliding windon (rsw)
// algorithm wrapper
//
//////////////////////////////////////////////////////////////////////

#ifndef _RSW_H_
#define _RSW_H_

namespace treecrf {

class DataSet;
class TreeCRF;

class RswEval {
 public:
  // Constructors
  RswEval(): k_val_(1) {};
  RswEval(int k_val): k_val_(k_val) {};

  // Predict the label sequence of a given sequence dataset
  void Predict(const DataSet & dataset,
               const TreeCRF & pfc,
               int* predict_classes);
 private:
  // Data Fields
  int k_val_; // the order of markov chain
};

} // namespace treecrf

#endif  // _RSW_H_
//////////////////////////////////////////////////////////////////////
