// File: rt-main.h
//
// Time-stamp: <2008-07-18 01:47:00 haog>
// Author: Guohua Hao <haog@eecs.oregonstate.edu>
//
// Copyright (C) 2008 Guohua Hao
// All Rights Reserved.
//
// Description: declaration of global variables.
//
//////////////////////////////////////////////////////////////////////

#ifndef _RT_MAIN_H_
#define _RT_MAIN_H_

#include "parameters.h"

namespace treecrf {

extern Parameters params;

extern int heapshrink;

// We have put these variables here because they are used by the
// potential function caching mechanisms.  Perhaps we should
// encapsulate them in a CacheInfo class?

// number of perfect cache hits (no recomputation required)
extern int CachePerfectHits;

// number of cache hits that required single-generation update
extern int CacheOneHits;

// number of cache misses (full recomputation required)
extern int CacheMisses;

extern int NCacheIDs;
extern int CacheSize;

extern int InputFeatures;
extern int NClasses;   // includes the extra (-1) off-end class

} // namespace treecrf

#endif  // _RT_MAIN_H_
//////////////////////////////////////////////////////////////////////
